/*
 * DECODE.cpp
 *
 *  Created on: 07.11.2018
 *      Author: Maxi
 */

#include "DECODE.h"


DECODE::DECODE() {
	// TODO Auto-generated constructor stub
    fProgress=0.00;
    strPath="";
}
DECODE::DECODE(std::string newPath){
    strPath=newPath;
    
    this->stream_UBXdata.open(newPath,std::ios::in|std::ios::binary);

    if(this->stream_UBXdata.is_open())//checks if file is referenced/"open"
    {
            std::cout << "file open ok" << std::endl;
    }
}

DECODE::~DECODE() {
	// TODO Auto-generated destructor stub
}
void DECODE::choiceFileType()
{
    //Parameter
    int iAmountChoices=2;//Please put in the amount of available Choices

    int iChoiceFileType;
    int iChoiceFormat;
    
    //Choose the file type
    std::cout<<"Which file type do you wish? .csv or .kml ?"<<std::endl;
    std::cout<<".csv: 0; .kml: 1"<<std::endl;
    std::cin>>iChoiceFileType;
    while(std::cin.fail()||(iChoiceFileType>(iAmountChoices-1))||(iChoiceFileType<0))
    {
        std::cout << "You entered:" <<iChoiceFileType<< std::endl;
        std::cout << "Failbit was detected!!!" << std::endl;
        std::cout << "Input is incorrect!!!" << std::endl;
        std::cout << "Please try again." << std::endl;
        std::cin>>iChoiceFileType;
    }
    
    //Decode to klm or to csv
    if(iChoiceFileType==0)
    {
        std::cout<<"You chose .csv-format!"<<std::endl;

        //chose format basic or complete
        iChoiceFormat=choiceFormat();
        //decode Ubx to csv
        decodeUbxToCsv(iChoiceFormat);
        //this->identifyUbxMsg();
    }
    else if(iChoiceFileType==1)
    {
        std::cout<<"You chose .kml-format!"<<std::endl;
        
        
        decodeUbxToKml();
    }
    
    
}
int DECODE::choiceFormat()
{
    //Parameter
    int iChoiceFormat;
    
    std::cout<<"Which format do you wish? Basic or Complete ?"<<std::endl;
    std::cout<<"Basic: Only includes the static variables. First 49 Columns"<<std::endl;
    std::cout<<"Complete: Basic + Includes all decodable loop objects. Dynamic Columns"<<std::endl;
    std::cout<<"Basic: 0; Complete: 1"<<std::endl;
    std::cin>>iChoiceFormat;
    while(std::cin.fail()||(iChoiceFormat>1)||(iChoiceFormat<0))
    {
        std::cout << "You entered:" <<iChoiceFormat<< std::endl;
        std::cout << "Failbit was detected!!!" << std::endl;
        std::cout << "Input is incorrect!!!" << std::endl;
        std::cout << "Please try again." << std::endl;
        std::cin>>iChoiceFormat;
    }
    return iChoiceFormat;
}

void DECODE::writeHeaderCsv(int &iFormat)
{
    int i=0;
    
    this->stream_TXTdata<<"HeadSyncChar1;HeadSyncChar2;HeadClass;HeadId;HeadLength;";
    this->stream_TXTdata<<"id"<<";";
    this->stream_TXTdata<<"resCode"<<";";
    this->stream_TXTdata<<"week"<<";";
    this->stream_TXTdata<<"tow"<<";";
    this->stream_TXTdata<<"weekInit"<<";";
    this->stream_TXTdata<<"towInit"<<";";
    this->stream_TXTdata<<"lat"<<";";
    this->stream_TXTdata<<"lon"<<";";
    this->stream_TXTdata<<"heigth"<<";";
    this->stream_TXTdata<<"ECEFX"<<";";
    this->stream_TXTdata<<"ECEFY"<<";";
    this->stream_TXTdata<<"ECEFZ"<<";";
    for(i=0;i<3;i++)
    {
        this->stream_TXTdata<<"b"<<i<<";";
    }
    for(i=0;i<3;i++)
    {
        this->stream_TXTdata<<"bStdDeviation"<<i<<";";
    }
    for(i=0;i<3;i++)
    {
        this->stream_TXTdata<<"vel"<<i<<";";
    }
    for(i=0;i<3;i++)
    {
        this->stream_TXTdata<<"velStdDev"<<i<<";";
    }
    for(i=0;i<3;i++)
    {
        this->stream_TXTdata<<"acc"<<i<<";";
    }
    for(i=0;i<3;i++)
    {
        this->stream_TXTdata<<"accStdDev"<<i<<";";
    }
    for(i=0;i<3;i++)
    {
        this->stream_TXTdata<<"att"<<i<<";";
    }
    for(i=0;i<3;i++)
    {
        this->stream_TXTdata<<"attStdDev"<<i<<";";
    }
    this->stream_TXTdata<<"accuracy"<<";";
    
    for(i=0;i<5;i++)
    {
        this->stream_TXTdata<<"timingInfo"<<i<<";";
    }
    
    this->stream_TXTdata<<"gnssReception"<<";";
    
    if(iFormat==0)
    {
        this->stream_TXTdata<<"numSat"<<std::endl;
    }
    else if(iFormat==1)
    {
        //fill Satellite columns for a static table structure
        this->stream_TXTdata<<"numSat"<<";";
        inflateSatellite();
        //Receiver
        this->stream_TXTdata<<"numRcv"<<std::endl;
    }
}
void DECODE::writeHeaderKml()
{
    this->stream_TXTdata << "<?xml version=\"1.0\" encoding=\"UTF-8\"?>" << std::endl;
    this->stream_TXTdata << "<kml xmlns=\"http://www.opengis.net/kml/2.2\">" << std::endl;
    this->stream_TXTdata << "<Document>" << std::endl;
    this->stream_TXTdata << "<name>ANavS RTK-Solution</name>" << std::endl;
    this->stream_TXTdata << "<description></description>" << std::endl;
    this->stream_TXTdata << "" << std::endl;
    this->stream_TXTdata << "" << std::endl;
    this->stream_TXTdata << "<!-- ++++++++++++++ STYLE DEFINITIONS ++++++++++++++ -->" << std::endl;
    this->stream_TXTdata << "<!-- PATH LINE -->" << std::endl;
    this->stream_TXTdata << "<Style id=\"orangeLine\">" << std::endl;
    this->stream_TXTdata << "<LineStyle>" << std::endl;
    this->stream_TXTdata << "<color>c01d94f7</color>" << std::endl;
    this->stream_TXTdata << "<width>4</width>" << std::endl;
    this->stream_TXTdata << "</LineStyle>" << std::endl;
    this->stream_TXTdata << "</Style>" << std::endl;
    this->stream_TXTdata << "<!-- CLICKABLE POINT -->" << std::endl;
    this->stream_TXTdata << "<Style id=\"bluePoint\">" << std::endl;
    this->stream_TXTdata << "<IconStyle>" << std::endl;
    this->stream_TXTdata << "<Icon>" << std::endl;
    this->stream_TXTdata << "<href>https://raw.githubusercontent.com/stucka/cheap_markers/master/images/small_blue.png</href>" << std::endl;
    this->stream_TXTdata << "</Icon>" << std::endl;
    this->stream_TXTdata << "<scale>0.4</scale>" << std::endl;
    this->stream_TXTdata << "</IconStyle>" << std::endl;
    this->stream_TXTdata << "</Style>" << std::endl;
    this->stream_TXTdata << "" << std::endl;
    this->stream_TXTdata << "<!-- ++++++++++++++ PATH COORDINATES ++++++++++++++ -->" << std::endl;
    this->stream_TXTdata << "<!-- ATTENTION: remember to split path every 20.000 points -->  " << std::endl;
    this->stream_TXTdata << "<Folder> " << std::endl;
    this->stream_TXTdata << "<name>Pathline ANavS RTK-Solution</name>" << std::endl;
    this->stream_TXTdata << "<description></description> " << std::endl;
    this->stream_TXTdata << "<visibility>1</visibility> " << std::endl;
    this->stream_TXTdata << "<Placemark>" << std::endl;
    this->stream_TXTdata << "<name>Path part #" <<iPathCount<<"</name>" << std::endl;
    this->stream_TXTdata << "<styleUrl>#orangeLine</styleUrl> " << std::endl;
    this->stream_TXTdata << "<LineString> " << std::endl;
    this->stream_TXTdata << "<extrude>1</extrude> " << std::endl;
    this->stream_TXTdata << "<altitudeMode>absolute</altitudeMode>" << std::endl;
    this->stream_TXTdata << "<tessellate>0</tessellate>" << std::endl;
    this->stream_TXTdata << "<coordinates>" << std::endl;
}
void DECODE::identifyUbxMsg(int iTypeOfFile,int iExtraParameter)
{
    //has the objective to identify the Messages in the stream
    //Therefore the header bits are used to identify the different Message-types
    //Moreover the decoding of the PAD-Solution is desired
    //Other Messages are ignored and skipped
    
    //Parameters
    int iReadingLength=20000;
    short iHeaderBytes=8;
    //Header Bits
    unsigned char msgSyncChar1, msgSyncChar2, msgClass, msgId;
    //unsigned short lengthPayload;
    
    //Helping variables
    bool bStopSearch=0;
    bool bSkippedBytes = false;
    bool bSuccessful;
    int iReadBytes=0;
    int i=0;// helps as placeholder for different applications
    int iReadingLimit=0;
    int iSize=0;
    char cArray[iReadingLength];
    //std::string strOutputPath="";
    
    //determine size of file
    this->stream_UBXdata.seekg( 0, std::ios::end );
    iSize=this->stream_UBXdata.tellg();
    std::cout <<"Total stream Size:"<<iSize<< std::endl;
    //Check if Stream actually exists
    if(iSize<0)
    {
        std::cout <<"There is no Data!!!"<< std::endl;
        std::cout <<"Change the Path or revise if File is really there"<< std::endl;
    }
    else
    {
        do
        {
            //load data in array
            this->stream_UBXdata.seekg (iReadBytes, std::ios::beg);

            pcArray=cArray;

            if((iSize-iReadBytes)>=(iReadingLength-1))//if the data to be loaded , is not
                //exceding the binary file, the custom amount of bytes can be loaded
            {
                this->stream_UBXdata.read (pcArray, iReadingLength);
                iReadingLimit=iReadBytes+iReadingLength-1;
            }
            else//if the stream ends 
            {
                i=(iSize-iReadBytes+1);
                this->stream_UBXdata.read (pcArray,i);
                iReadingLimit=iReadBytes+i-1;
                bStopSearch=1;//stop general/first loop
                std::cout<<"The Last chunk of the file was loaded into memory."<<std::endl;
            }

            while( iReadBytes<=(iReadingLimit-iHeaderBytes))
            {
                // Message header.
                msgSyncChar1 = CpyUnsignChar(&pcArray);
                //std::cout <<"SyncChar1-pointer:"<<(int)pcArray<< endl;
                msgSyncChar2 = CpyUnsignChar(&pcArray);
                //std::cout <<"SyncChar2-pointer:"<<pcArray<< endl;
                msgClass = CpyUnsignChar(&pcArray);
                //std::cout <<"Class-pointer:"<<pcArray<< endl;
                msgId = CpyUnsignChar(&pcArray);
                //std::cout <<"Id-pointer:"<<pcArray<< endl;   
                //std::cout <<"while schleife"<< std::endl;
                
                if(msgSyncChar1==181 && msgSyncChar2==98 && msgClass==2 && msgId == 224)
                {
                    //std::cout <<"ubx if statement"<< std::endl;
                    //define length
                    lengthPayload=CpyUnsignShort(&pcArray);
                    
                    
                    //break loop if the cArray does not contain all 
                    if ( iReadBytes + lengthPayload + 8 > iReadingLimit )
                    {
                        //std::cout <<"Break 1"<< std::endl;
                        break;//breaks the first loop 
                    }
                    
                            
                    //feed the Pad pointer with new data
                    this->padsolution->chosenSatSys(bGPS,bEGNOS,bGLONASS,bGALILEO);
                    this->padsolution->readOfFile(&pcArray,&bSuccessful);
                    
                    
                    //chooses which output format is used 
                    if ( bSuccessful==1 && iTypeOfFile==0)//.csv-file
                    {
                        //writing to file
                        this->stream_TXTdata<<(int)msgSyncChar1<<";";
                        this->stream_TXTdata<<(int)msgSyncChar2<<";";
                        this->stream_TXTdata<<(int)msgClass<<";";
                        this->stream_TXTdata<<(int)msgId<<";";
                        this->stream_TXTdata<<lengthPayload<<";";
                        this->writeToCsv(iExtraParameter);
                    }
                    else if( bSuccessful==1 && iTypeOfFile==1)//.kml-file
                    {
                        this->writeToKml(iExtraParameter);
                    }
                    else if( bSuccessful==0 )//ONLY FOR DEVELOPMENT PURPOSES!!!!!
                    {
                        //This CODE only serves for the purpose of stoping after
                        //the first line of a certain loop (satelliete, receiver, etc...)
                        
                        //writing to file
                        this->stream_TXTdata<<(int)msgSyncChar1<<";";
                        this->stream_TXTdata<<(int)msgSyncChar2<<";";
                        this->stream_TXTdata<<(int)msgClass<<";";
                        this->stream_TXTdata<<(int)msgId<<";";
                        this->stream_TXTdata<<lengthPayload<<";";
                        
                        this->padsolution->writeInCsv(this->stream_TXTdata,iExtraParameter);
                        bStopSearch=1;
                        iReadBytes=iReadingLimit;
                        break;
                        //pcArray += lengthPayload - 13;
                    }
                    // Skip checksum
                    pcArray+=2;
                    // Update read bytes (sync. chars + class + ID + payload length + payload + checksum)
                    iReadBytes += (8 + lengthPayload);
                }

                else if ( msgSyncChar1 == 181 && msgSyncChar2 == 98 && msgClass == 2 && msgId == 225 )
                {
                    lengthPayload=CpyUnsignShort(&pcArray);

                    if ( iReadBytes + lengthPayload + 8 >  iReadingLimit)
                    {
                        //std::cout <<"Break 2"<< std::endl;
                        break;
                    }
                    // Skip content of ubx message
                    pcArray+=lengthPayload;
                    // Skip checksum
                    pcArray+=2;

                    // Adapt read iReadBytes (sync. chars + class + ID + payload length + payload + checksum)
                    iReadBytes += (8 + lengthPayload);
                }
                //BarometerMsg
                else if ( msgSyncChar1 == 181 && msgSyncChar2 == 98 && msgClass == 2 && msgId == 226 )
                {
                    

                    if ( iReadBytes + lengthPayload + 8 > iReadingLimit  )
                    {
                        //std::cout <<"Break 3"<< std::endl;
                        break;
                    }
                    // Skip content of ubx message
                    pcArray+=lengthPayload;
                    // Skip checksum
                    pcArray+=2;

                    // Adapt read iReadBytes (sync. chars + class + ID + payload length + payload + checksum)
                    iReadBytes +=( 8 + lengthPayload);
                }

                //Odometrie
                else if ( msgSyncChar1 == 181 && msgSyncChar2 == 98 && msgClass == 2 && msgId == 227 )
                {
                    lengthPayload=CpyUnsignShort(&pcArray);

                    if ( iReadBytes + lengthPayload + 8 > iReadingLimit  )
                    {
                        //std::cout <<"Break 4"<< std::endl;
                        break;
                    }
                    // Skip content of ubx message
                    pcArray+=lengthPayload;
                    // Skip checksum
                    pcArray+=2;

                    // Adapt read iReadBytes (sync. chars + class + ID + payload length + payload + checksum)
                    iReadBytes +=(8 + lengthPayload);
                }
                else if ( msgSyncChar1 == 181 && msgSyncChar2 == 98 && msgClass == 2 && msgId == 228 )
                {
                    lengthPayload=CpyUnsignShort(&pcArray);

                    if ( iReadBytes + lengthPayload + 8 > iReadingLimit)
                    {
                        //std::cout <<"Break 5"<< std::endl;
                        break;
                    }

                    // Skip content of ubx message
                    pcArray+=lengthPayload;// gnssReceptionValue2 = R8(&p);
                    // Skip checksum
                    pcArray+=2;

                    // Adapt read iReadBytes (sync. chars + class + ID + payload length + payload + checksum)
                    iReadBytes += (8 + lengthPayload);
                }
                else
                {
                    bSkippedBytes = true;
                    pcArray -= 3; // Skipped 4 iReadBytes due to the message header. Therefore, adapt pointer so that no byte is skipped.
                    iReadBytes++;
                }
                //tell Progress
                tellProgress(iSize,iReadBytes);
            }

        }while(bStopSearch==0);

        //read id
        //this->stream_UBXdata.read( (char*) &id , sizeof(char));
        //std::cout <<"ID:"<<id<< endl;
        //pposition=this->stream_UBXdata.tellg();
        //std::cout <<"PointerPosition:"<<pposition<< endl;
        //read resCode
        //this->stream_UBXdata.read( (char*) &resCode , sizeof(unsigned short));

        if ( bSkippedBytes )
        {
            std::cout << "UBX decoding: skipped bytes (PAD solution)." << std::endl;
        }

    }
}
void DECODE::writeToCsv(int &iFormat)//has the objective to convert the ubx Messages into a csv format
{
    //write every information from the Pad pointer in the file
    this->padsolution->writeInCsv(this->stream_TXTdata,iFormat);
    
    resetPointers();
}
void DECODE::writeToKml(int &iMode)//has the objective to convert the ubx Messages into a kml format
{
    unsigned short usResCode=this->padsolution->getResultCode();
    unsigned short usGnssEpoch=0;
    unsigned short usFixedSolution=0;
    unsigned short usFloatSolution=0;
    unsigned short usLeastSquareSolution=0;
    
    
    usGnssEpoch = (unsigned short)(usResCode &          0b0000000000000001);//0b0000000000000001=1
    usFixedSolution = (unsigned short)(usResCode &      0b0001100000000000);//0b0001100000000000=6144
    usFloatSolution=(unsigned short)(usResCode &        0b0001000000000000);//0b0001000000000000=4096
    usLeastSquareSolution=(unsigned short)(usResCode &  0b0000100000000000);//0b0000100000000000=2048
    //std::cout<<"GNSS Epoch:"<<usGnssEpoch<<std::endl;
    //std::cout<<"Fixed Solution:"<<usFixedSolution<<std::endl;

    //only write information from the Pad pointer in the file
    //if meassurement from GNSS upadate epoch
    //if usFixedSolution!=0 then 
    //all FloatSolution and LeastSquareSolution are also included
    
    if ((usGnssEpoch==1)&&((usFixedSolution==6144)|| (usFloatSolution==4096)||(usLeastSquareSolution==2048)))
    {
        //std::cout<<"Solution:"<<usFixedSolution<<std::endl;

        iCoordinatesCount++;
        this->padsolution->writeInKml(this->stream_TXTdata,iMode);
        
        //divide Path coordinates into chunks of 20000 Points
        if ( (iMode==0) && (iCoordinatesCount%20000==0) )//should only be activated
            //if path coordinates are being written
        {
            iPathCount++;//Increase Path counter for new pathline header/stack
            std::cout<<"PathCount:"<<iPathCount<<std::endl;
            std::cout<<"CoordinateCount:"<<iCoordinatesCount<<std::endl;
            
            this->stream_TXTdata << "</coordinates>" << std::endl;
            this->stream_TXTdata << "</LineString>" << std::endl;
            this->stream_TXTdata << "</Placemark>" << std::endl;
            this->stream_TXTdata << "" << std::endl;
            this->stream_TXTdata << "<Placemark>" << std::endl;
            this->stream_TXTdata << "<name>Path part #" <<iPathCount<<"</name>" << std::endl;
            this->stream_TXTdata << "<styleUrl>#orangeLine</styleUrl> " << std::endl;
            this->stream_TXTdata << "<LineString> " << std::endl;
            this->stream_TXTdata << "<extrude>1</extrude> " << std::endl;
            this->stream_TXTdata << "<altitudeMode>absolute</altitudeMode>" << std::endl;
            this->stream_TXTdata << "<tessellate>0</tessellate>" << std::endl;
            this->stream_TXTdata << "<coordinates>" << std::endl;
        }
    }
    
    resetPointers();
}
void DECODE::resetPointers()
{
    //save vector size of satellite vector for skipping the char pointer
    iSatVectorSize=this->padsolution->getVectorSize();

    //Reset the objects in order not to pass false values
    this->padsolution->clearVector();//destroy all objects in the satellite vector
    
    try
    {
       this->padsolution->resetPointers();
       delete padsolution;
       padsolution=nullptr;
       padsolution=new PAD;
       if (!padsolution||padsolution==nullptr)
       {
           std::cout << "allocation of memory failed\n";
       }
    }
    catch(const std::bad_alloc& e)
    {
        std::cout << "Allocation failed in DECODE: " << e.what() << '\n';
    }
    
    //skip the the rest of the payload
    //370 is the amount of bytes from the constant variables at the beginning of the MSG
    //from id to numSats
    //18 is the amount of bytes of the satellite attributes
    //1 is the amount of bytes of NumRcv
    pcArray+= (lengthPayload-370-18*iSatVectorSize-1);
}

void DECODE::decodeUbxToCsv(int iFormat)
{
    //Parameter
    std::string strOutputPath="";
    
    
    //if compiling on windows
    strOutputPath="PADSolution.csv";
    //if compiling on linux
    //strOutputPath="//home//maxi//.netbeans//remote//192.168.7.129//maxi-surface-Windows-x86_64//C//Users//Maxi//Documents//Privat//Praktikum//ANavS_2018//NetBeans//UBXproject//PADSolution.csv";
   
    //open stream of .csv-file
    this->stream_TXTdata.open(strOutputPath, std::ofstream::out | std::ofstream::trunc);
    //write csv header
    //if(iFormat==0)
    //{
        writeHeaderCsv(iFormat);
    //}
    this->identifyUbxMsg(0,iFormat);
    
    std::cout<<"Decoding from .ubx to .csv has finished"<<std::endl;
    //close stream to avoid any memory problems
    stream_TXTdata.close();
}
void DECODE::decodeUbxToKml()
{
    //Parameter
    std::string strOutputPath="";
    int iMode=0;//Mode=0 has to write header and path coordinates
    //Mode=1 has to write Placemarkers
    //Mode=2 writes the end of the file and is finished
    iPathCount=1;
    iCoordinatesCount=0;
    
    //open kml-file
    strOutputPath="PADSolution.kml";
    this->stream_TXTdata.open( strOutputPath, std::ofstream::out | std::ofstream::trunc);
    //write Header
    writeHeaderKml();
    
    //write Path coodinates in File
    this->identifyUbxMsg(1,iMode);
    //write ending test for path coordinates
    this->stream_TXTdata << "</coordinates>" << std::endl;
    this->stream_TXTdata << "</LineString>" << std::endl;
    this->stream_TXTdata << "</Placemark>" << std::endl;
    this->stream_TXTdata << "</Folder>" << std::endl;
    this->stream_TXTdata << "" << std::endl;
    this->stream_TXTdata << "<Folder> " << std::endl;
    this->stream_TXTdata << "<name>Markers ANavS RTK-Solution</name>" <<std::endl;
    this->stream_TXTdata << "<description></description> " << std::endl;
    this->stream_TXTdata << "<visibility>1</visibility> " << std::endl;
    this->stream_TXTdata << "" << std::endl;
    //change mode
    iMode++;
    
    //std::cout<<"Mode"<<iMode<<"\n Next Loop is going to be initiated"<<std::endl;
    //std::cout<<"Position of stream"<<stream_UBXdata.tellg()<<std::endl;
    this->stream_UBXdata.seekg (0, std::ios::beg);
    //std::cout<<"Position of stream"<<stream_UBXdata.tellg()<<std::endl;
    
    this->stream_UBXdata.close();
    this->stream_UBXdata.open(strPath,std::ios::in|std::ios::binary);
    if(this->stream_UBXdata.is_open())//checks if file is referenced/"open"
    {
            std::cout << "file open ok" << std::endl;
    }
    std::cout<<"Position of stream"<<stream_UBXdata.tellg()<<std::endl;
    
    //write Placemarkers in file
    this->identifyUbxMsg(1,iMode);
    
    this->stream_TXTdata << "</Folder>" << std::endl;
    this->stream_TXTdata << "" << std::endl;
    this->stream_TXTdata << "</Document>" << std::endl;
    this->stream_TXTdata << "</kml>" << std::endl;
    
    //close stream to avoid any memory problems
    stream_TXTdata.close();
}
void DECODE::tellProgress(int &iMaximumSize, int&iKnownBytes)
{
    
    float fTempProgress=0.00;
    
    //iPosition=stream_TXTdata.tellp();
    //fTempProgress=fProgress;
    
    fTempProgress=((float)(iKnownBytes)/(float)iMaximumSize)*100;
    
    if(fTempProgress>=(fProgress+5.0))
    {
        fProgress=fTempProgress;
        std::cout.setf(std::ios_base::fixed, std::ios_base::floatfield);
        std::cout<<"Progress:"<<std::setprecision(0)<<fProgress<<"%"<<std::endl;
        std::cout.unsetf(std::ios_base::floatfield);//normalize the precision
    }
}

void DECODE::inflateSatellite()
{
    //bool bGPS=1;
    //bool bGLONASS=1;
    //bool bGALILEO=1;
    int i=0;
    //*****************************************************************************
    std::cout << "Which Satellite System would you like to decode?" << std::endl;
    std::cout << "Would you like to decode GPS?\n 0=No 1=Yes" << std::endl;
    std::cin>>bGPS;
    //Certify if input is correct
    while(std::cin.fail())
    {
        std::cout << "You entered:" << bGPS << std::endl;
        std::cout << "Failbit was detected!!!" << std::endl;
        std::cout << "Input is incorrect!!!" << std::endl;
        std::cout << "Please try again" << std::endl;
        //clear failbit
        std::cin.clear();
        std::cin.ignore(1000,'\n');
        //write path in stream
        std::cin>>bGPS;   
    }
    //*****************************************************************************
    std::cout << "Would you like to decode SBAS(EGNOS)?\n 0=No 1=Yes" << std::endl;
    std::cin>>bEGNOS;
    //Certify if input is correct
    while(std::cin.fail())
    {
        std::cout << "You entered:" << bEGNOS << std::endl;
        std::cout << "Failbit was detected!!!" << std::endl;
        std::cout << "Input is incorrect!!!" << std::endl;
        std::cout << "Please try again" << std::endl;
        //clear failbit
        std::cin.clear();
        std::cin.ignore(1000,'\n');
        //write path in stream
        std::cin>>bEGNOS;   
    }
    //*****************************************************************************
    std::cout << "Would you like to decode GLONASS?\n 0=No 1=Yes" << std::endl;
    std::cin>>bGLONASS;
    //Certify if input is correct
    while(std::cin.fail())
    {
        std::cout << "You entered:" <<bGLONASS << std::endl;
        std::cout << "Failbit was detected!!!" << std::endl;
        std::cout << "Input is incorrect!!!" << std::endl;
        std::cout << "Please try again" << std::endl;
        //clear failbit
        std::cin.clear();
        std::cin.ignore(1000,'\n');
        //write path in stream
        std::cin>>bGLONASS;   
    }
    //*****************************************************************************
    std::cout << "Would you like to decode GALILEO?\n 0=No 1=Yes" << std::endl;
    std::cout << "NOTE: If GALILEO is not chosen then BEIDOU/COMPASS is chosen instead." << std::endl;
    std::cin>>bGALILEO;
    //Certify if input is correct
    while(std::cin.fail())
    {
        std::cout << "You entered:" << bGALILEO << std::endl;
        std::cout << "Failbit was detected!!!" << std::endl;
        std::cout << "Input is incorrect!!!" << std::endl;
        std::cout << "Please try again" << std::endl;
        //clear failbit
        std::cin.clear();
        std::cin.ignore(1000,'\n');
        //write path in stream
        std::cin>>bGALILEO;   
    }
    //*****************************************************************************
    if(bGPS)
    {
        for (i=0;i<MaxSatellitesGPS;i++)
        {
            stream_TXTdata<<"GPS"<<"gnssId"<<i<<";";
            stream_TXTdata<<"GPS"<<"svId"<<i<<";";
            stream_TXTdata<<"GPS"<<"elev"<<i<<";";
            stream_TXTdata<<"GPS"<<"azim"<<i<<";";
        }
    }
    if(bEGNOS)
    {
        for (i=0;i<MaxSatellitesEGNOS;i++)
        {
            stream_TXTdata<<"SBAS"<<"gnssId"<<i<<";";
            stream_TXTdata<<"SBAS"<<"svId"<<i<<";";
            stream_TXTdata<<"SBAS"<<"elev"<<i<<";";
            stream_TXTdata<<"SBAS"<<"azim"<<i<<";";
        }
    }
    if(bGLONASS)
    {
        for (i=0;i<MaxSatellitesGLONASS;i++)
        {
            stream_TXTdata<<"GLO"<<"gnssId"<<i<<";";
            stream_TXTdata<<"GLO"<<"svId"<<i<<";";
            stream_TXTdata<<"GLO"<<"elev"<<i<<";";
            stream_TXTdata<<"GLO"<<"azim"<<i<<";";
        }
    }
    
    if(bGALILEO)
    {
        for (i=0;i<MaxSatellitesGALILEO;i++)
        {
            stream_TXTdata<<"GAL"<<"gnssId"<<i<<";";
            stream_TXTdata<<"GAL"<<"svId"<<i<<";";
            stream_TXTdata<<"GAL"<<"elev"<<i<<";";
            stream_TXTdata<<"GAL"<<"azim"<<i<<";";
        }
    }
    else if(bGALILEO==0)
    {
        for (i=0;i<MaxSatellitesBEIDOU;i++)
        {
            stream_TXTdata<<"BEI"<<"gnssId"<<i<<";";
            stream_TXTdata<<"BEI"<<"svId"<<i<<";";
            stream_TXTdata<<"BEI"<<"elev"<<i<<";";
            stream_TXTdata<<"BEI"<<"azim"<<i<<";";
        }
    }
}
